// Header File
// Created 6/6/2004; 2:26:40 PM

#ifndef _ENEMY_H_
#define _ENEMY_H_

#include "gfx.h"
#include "weapon.h"

typedef enum { SHIELDGEN=1, FIGHTER=2, COPTER=3, BARRIER=4, GENERATOR=10 } EnemyType;

typedef struct {

	Angle spin[4];
	Point momentum[4];
	unsigned char numintervals;
	unsigned char time_interval[4];
	unsigned char current_time;
	unsigned char current_interval;

	Point location;
	Angle angle;

	Line *objlines;
	unsigned char numlines;

	unsigned char damage;
	unsigned char maxdamage;

	unsigned char square;

	EnemyType type;

	Weapon weapon;
	short fireRatio;
	Point fireMomentum;

} Enemy;

short checkEnemyCollision(Enemy *this, Point *location);
void createEnemyShieldGen(Enemy *this);
void createEnemyFighter(Enemy *this);
void createEnemyGenerator(Enemy *this);
void createEnemyCopter(Enemy *this);
void moveEnemy(Enemy *this);

#endif