// C Source File
// Created 6/5/2004; 5:59:13 PM

#ifndef _SHIP_C_
#define _SHIP_C_

#include "ship.h"

void setupShipDefaults(Ship *this)
{
	this->energy = 100;
	this->chargeRate = 1;
	this->angle = newAngle(0, 0, 0);
	this->location = newPoint(0, 0, 0);
	this->momentum = newPoint(0, 0, 0);
	this->numweapons = 0;
	this->maxweapons = 10;
	this->score = 0;
	this->shield = 100;
}

void createShipA(Ship *this)
{
	setupShipDefaults(this);

	this->numlines = SHIP_A_LINEMAX;

	this->objlines[ 0].point[0] = newPoint( -4,   0,  -5);
	this->objlines[ 0].point[1] = newPoint(  4,   0,  -5);

	this->objlines[ 1].point[0] = newPoint( -4,  -4,   2);
	this->objlines[ 1].point[1] = newPoint(  4,  -4,   2);

	this->objlines[ 2].point[0] = newPoint( -4,   0,  -5);
	this->objlines[ 2].point[1] = newPoint( -4,  -4,   2);

	this->objlines[ 3].point[0] = newPoint(  4,   0,  -5);
	this->objlines[ 3].point[1] = newPoint(  4,  -4,   2);

	this->objlines[ 4].point[0] = newPoint( -4,   0,  -5);
	this->objlines[ 4].point[1] = newPoint( -9,   1,   3);

	this->objlines[ 5].point[0] = newPoint(  4,   0,  -5);
	this->objlines[ 5].point[1] = newPoint(  9,   1,   3);

	this->objlines[ 6].point[0] = newPoint( -4,  -4,   2);
	this->objlines[ 6].point[1] = newPoint( -9,   1,   3);

	this->objlines[ 7].point[0] = newPoint(  4,  -4,   2);
	this->objlines[ 7].point[1] = newPoint(  9,   1,   3);

	this->objlines[ 8].point[0] = newPoint( -4,   0,   2);
	this->objlines[ 8].point[1] = newPoint( -4,   6,   5);

	this->objlines[ 9].point[0] = newPoint( -4,   6,   5);
	this->objlines[ 9].point[1] = newPoint( -4,  -6,   5);

	this->objlines[10].point[0] = newPoint( -4,  -6,   5);
	this->objlines[10].point[1] = newPoint( -4,   0,   2);

	this->objlines[11].point[0] = newPoint(  4,   0,   2);
	this->objlines[11].point[1] = newPoint(  4,   6,   5);

	this->objlines[12].point[0] = newPoint(  4,   6,   5);
	this->objlines[12].point[1] = newPoint(  4,  -6,   5);

	this->objlines[13].point[0] = newPoint(  4,  -6,   5);
	this->objlines[13].point[1] = newPoint(  4,   0,   2);


}

void registerWeapon(Ship *this, Weapon *laser)
{
	if (this->numweapons < this->maxweapons) {
		this->weapons[this->numweapons] = *laser;
		this->weapons[this->numweapons].location = this->location;

		this->numweapons++;
	}
}

void deleteWeapon(Ship *this, int id)
{
	if (this->numweapons > 0) {
		this->numweapons--;
		this->weapons[id] = this->weapons[this->numweapons];
	}
}



#endif
